import { OnInit, EventEmitter } from '@angular/core';
import { InteractiveGraphService } from './interactive-graph.service';
import { InteractionType, Interactable } from './logic/index';
import { InteractiveGraph } from './logic/lib/interactive/interactiveGraph';
export declare class CustomInteractiveGraphComponent implements OnInit {
    private readonly canvasID;
    graph: InteractiveGraph;
    isEditable: boolean;
    isSTExercise: boolean;
    hasUnit: boolean;
    language: string;
    showLanguageOption: boolean;
    isMandatoryNodeExercise: boolean;
    isPrefixNodeExercise: boolean;
    graphListener: EventEmitter<{
        interactionType: InteractionType;
        object: any;
    }>;
    interactionType: InteractionType;
    iMoveNode: InteractionType;
    iCreateNode: InteractionType;
    iCreateEdge: InteractionType;
    iDelete: InteractionType;
    selectID: string;
    addNodeID: string;
    addEdgeID: string;
    deleteID: string;
    moveID: string;
    sourceID: string;
    targetID: string;
    renameID: string;
    weightID: string;
    prefixID: string;
    mandatoryID: string;
    buttonColor: string;
    buttonColorSelected: string;
    selectInteraction: HTMLSelectElement;
    buttonMapping: Map<String, HTMLButtonElement>;
    resetButton: HTMLButtonElement;
    resetID: string;
    undoButton: HTMLButtonElement;
    undoID: string;
    protected service: InteractiveGraphService;
    constructor(service: InteractiveGraphService);
    ngOnInit(): void;
    onChangeLanguage(): void;
    translate(word: string): string;
    ngAfterViewInit(): void;
    latestClickID: string;
    onClickButton(buttonID: string): void;
    hideAllButtons(exceptID?: string): void;
    resetButtonColor(exceptID?: string): void;
    reset(): void;
    undo(): void;
    onUndo: () => void;
    onReset: () => void;
    onMove: () => void;
    onAddNode: () => void;
    onAddEdge: () => void;
    onDelete: () => void;
    onSourceNode: () => void;
    onTargetNode: () => void;
    onMandatoryNode: () => void;
    onPrefixNode: () => void;
    lastActive: Interactable;
    getActive(): Interactable;
    onChange: () => void;
    onChangeUnit: () => void;
    initUnit: boolean;
    changeUnit(): void;
    onChangeValueHandler(): void;
    changeInteractionHandler: (val: any) => void;
    changeInteraction(i: number): void;
}
