import { AbstractGrid } from "./aGrid";
/**
 * Drawable objects on the canvas should extend this class
 */
export declare abstract class Drawable {
    protected readonly priority: number;
    protected visibility: OPACITY;
    constructor(priority: number);
    /**
     * @returns returns drawing priority
     */
    getPriority(): number;
    setVisibility(v: OPACITY): void;
    getVisibility(): OPACITY;
    update(ctx: CanvasRenderingContext2D, grid: AbstractGrid): void;
    protected abstract draw(ctx: CanvasRenderingContext2D, grid: AbstractGrid): void;
    static isDrawable(object: any): object is Drawable;
}
export declare enum OPACITY {
    VISIBLE = 0,
    INVISIBLE = 1,
    TRANSPARENT = 2
}
