import { AbstractGrid } from "../abstract/aGrid";
import { Drawable } from "../abstract/drawable";
import { Grid } from "../base/grid";
import { Interactable } from "../abstract/interactable";
export declare class GraphGrid extends Grid {
    protected numRows: number;
    protected numCols: number;
    protected canvas: HTMLCanvasElement;
    drawableMapping: Map<Drawable, [number, number]>;
    static readonly DEFAULT_NUMROW: number;
    static readonly DEFAULT_NUMCOL: number;
    protected windowRatio: number;
    constructor(canvas?: HTMLCanvasElement, numRows?: number, numCols?: number);
    reset(): void;
    setupCanvas(canvas: HTMLCanvasElement): void;
    draw(ctx: CanvasRenderingContext2D, grid: AbstractGrid): void;
    onResize(): void;
    draggedDrawable: Drawable;
    addCoordinate(drawable: Drawable, coordinate: [number, number], round?: boolean, dragged?: boolean): void;
    getCoordinate(drawable: Drawable): [number, number];
    getInteractable(coordinate: [number, number]): Interactable;
    private convert;
    convertCoordinateToRaw(coordinate: [number, number], obj?: Drawable): [number, number];
    private reconvert;
    deleteCoordinate(drawable: Drawable): boolean;
    printInformation(): void;
    getCanvasWidth(): number;
    getCanvasHeight(): number;
    getNodeWidth(): number;
    getNodeHeight(): number;
    getColsNumber(): number;
    getRowsNumber(): number;
}
