import { AbstractNode } from "../abstract/aNode";
import { AbstractEdge } from "../abstract/aEdge";
import { InteractiveGraph } from "./interactiveGraph";
export declare class ActionHistory {
    private history;
    private canvas;
    private graph;
    private grid;
    private interactiveGraph;
    private index;
    constructor(canvas: HTMLCanvasElement, interactiveGraph: InteractiveGraph);
    resetHistory(): void;
    revertAction(steps?: number): void;
    /**
     * Not working. Don't use. Maybe later?
     */
    redoAction(steps?: number): void;
    private redo;
    private revert;
    private addAction;
    addMove(node: AbstractNode): void;
    addCreateNode(node: AbstractNode): void;
    addCreateEdge(edge: AbstractEdge): void;
    addSourceNode(node: AbstractNode): void;
    addTargetNode(node: AbstractNode): void;
    deleteNode(node: AbstractNode): void;
    deleteEdge(edge: AbstractEdge): void;
    printHistory(): void;
    private convert;
    private reconvert;
}
